#define CONFIGURE_INIT
#include <rtems.h>

rtems_task Init( rtems_task_argument argument );

/* configuration information */
#include <bsp.h>

#define CONFIGURE_APPLICATION_NEEDS_CONSOLE_DRIVER
#define CONFIGURE_APPLICATION_NEEDS_CLOCK_DRIVER
#define CONFIGURE_MAXIMUM_TASKS            		32
#define	CONFIGURE_MAXIMUM_TIMERS			 	32
#define CONFIGURE_RTEMS_INIT_TASKS_TABLE
#define CONFIGURE_USE_MINIIMFS_AS_BASE_FILESYSTEM

#include <confdefs.h>
#include <stdio.h>

rtems_id statistics_timer;
extern unsigned int max_rdtsc[];

rtems_timer_service_routine
statistics_fire_proc( rtems_id timer_id, void *unused )
{
	int i;
	for ( i=0; i<16; i++ ) {
		if ( (i&7) == 0 ) printf("\n");
		printf("t%d:%u ",i,max_rdtsc[i]);
		max_rdtsc[i] = 0;
	}
	printf("\n");
	rtems_timer_reset( timer_id );
}

rtems_task Init(
  rtems_task_argument ignored
)
{
	rtems_status_code status;
	rtems_name name;
	rtems_interval ticks_per_second;

	rtems_clock_get( RTEMS_CLOCK_GET_TICKS_PER_SECOND, &ticks_per_second );

	name = rtems_build_name( 'T', 'E', 'S', 'T' );
	status = rtems_timer_create( name, &statistics_timer );
	if ( status != RTEMS_SUCCESSFUL ) rtems_fatal_error_occurred(status);

	status = rtems_timer_fire_after( statistics_timer,
									 ticks_per_second,
									 statistics_fire_proc,
									 NULL);
	if ( status != RTEMS_SUCCESSFUL ) rtems_fatal_error_occurred(status);
	printf( "\n\ninterrupt measurement start.\n" );
	rtems_task_suspend( RTEMS_SELF );
}
